/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.128
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.54 2009/12/06 09:34:36 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.128 2012/05/07 21:28:01 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
16 18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
17IUSE="${IUSE} debug pch" 43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="virtual/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
18RDEPEND=" 56RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
25 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
34 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
35 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
43 !<x11-libs/qt-webkit-${PV} 89 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 90 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 91 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 92 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 93"
48case "${PV}" in
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}"
52 ;;
53 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}"
55 MY_PV="${PV}"
56 ;;
57esac
58 94
59if version_is_at_least 4.5.99999999 ${PV} ; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}"
61else
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi
64S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
65 96
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 98# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then 102
88 # Make sure debug setting corresponds with qt-core (bug 258512) 103 # Protect users by not allowing downgrades between releases
89 if [[ $PN != "qt-core" ]]; then 104 # Downgrading revisions within the same release should be allowed
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 105 if has_version '>'${CATEGORY}/${P}-r9999; then
91 ~x11-libs/qt-core-${PV} debug" 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
92 fi 114 fi
115 fi
93 116
94 # Check USE requirements 117 if [[ ${PN} == qt-webkit ]]; then
95 qt4-build_check_use 118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
96 fi 126 fi
127 eshopts_pop
128 fi
97 129
98 PATH="${S}/bin:${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
131 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
133 else
134 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
135 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
136 # platform detection. Note: needs to come before any directories to
137 # avoid extract failure.
138 [[ ${CHOST} == *-apple-darwin* ]] && \
139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
140 ${QT4_EXTRACT_DIRECTORIES}"
141 fi
100 142
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 143 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
103 echo
104 ebeep 3
105 fi 145 fi
106
107 if [[ "${P}" == "qt-core-4.6.0_rc1" ]]; then
108 ewarn
109 ewarn "Binary compatibility broke between 4.6.0_beta1 and 4.6.0_rc1."
110 ewarn "If you are upgrading from 4.6.0_beta1, you'll have to"
111 ewarn "re-emerge everything that depends on Qt."
112 ewarn "Use the following command:"
113 ewarn
114 ewarn " emerge -av1 \$(for i in \$(qlist -IC x11-libs/qt-);"
115 ewarn " do equery -q d \$i | grep -v 'x11-libs/qt-' |"
116 ewarn " sed \"s/^/=/\"; done)"
117 ewarn
118 ewarn "YOU'VE BEEN WARNED"
119 ewarn
120 ebeep 3
121 fi
122
123} 146}
124 147
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 149# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
129 152
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION: 154# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
133# tarball 156# Qt tarball.
134 157
135# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 159# @DESCRIPTION:
137# Unpacks the sources 160# Unpacks the sources.
138qt4-build_src_unpack() { 161qt4-build_src_unpack() {
139 setqtenv 162 setqtenv
140 local target targets licenses tar_pkg tar_args 163
141 if version_is_at_least 4.5 ${PV} ; then 164 case ${QT4_BUILD_TYPE} in
142 licenses="LICENSE.GPL3 LICENSE.LGPL" 165 live)
143 else 166 git-2_src_unpack
144 licenses="LICENSE.GPL2 LICENSE.GPL3" 167 ;;
145 fi 168 release)
146 for target in configure ${licenses} projects.pro \ 169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
147 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
148 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
149 targets="${targets} ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
150 done 175 done
151 176
152 tar_pkg=${MY_P}.tar.bz2 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
153 tar_args="xjpf" 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
154 if version_is_at_least 4.5.3 ${PV} ; then 179 eend $? || die "failed to unpack"
155 tar_pkg=${tar_pkg/bz2/gz}
156 tar_args="xzpf"
157 fi
158
159 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
160 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
161
162 case "${PV}" in
163 4.4.?)
164 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
165 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
166 ;; 180 ;;
167 esac 181 esac
168
169 # Be backwards compatible for now
170 if [[ $EAPI != 2 ]]; then
171 qt4-build_src_prepare
172 fi
173} 182}
174 183
175# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
176# @DESCRIPTION: 186# @DESCRIPTION:
177# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
178# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
179# example: 189# Make sure to specify the full path. This variable is utilised in
180# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
181# ${FILESDIR}"/mypatch2.patch"
182# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
183 196
184# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
185# @DESCRIPTION: 198# @DESCRIPTION:
186# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
187# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
188qt4-build_src_prepare() { 201qt4-build_src_prepare() {
189 setqtenv 202 setqtenv
190 cd "${S}" 203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
215
216 if use aqua; then
217 # provide a proper macx-g++-64
218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
219
220 sed -e '/^CONFIG/s:app_bundle::' \
221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223 fi
191 224
192 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
193 skip_qmake_build_patch 226 skip_qmake_build
194 skip_project_generation_patch 227 skip_project_generation
195 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
196 fi 229 fi
197 230
198 # Bug 282984 && Bug 295530 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
199 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \ 232 # qmake bus errors with -O2 or -O3 but -O1 works
200 -i configure || die "sed qmake compilers failed" 233 # Bug 373061
201 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \ 234 replace-flags -O[23] -O1
202 -i config.tests/unix/compile.test || die "sed test compilers failed" 235 fi
203 236
204 # Bug 178652 237 # Bug 178652
205 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
207 append-flags -fno-gcse 240 append-flags -fno-gcse
208 fi 241 fi
209 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
210 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
211 if [[ $(gcc-major-version) -lt "4" ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
212 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
213 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
214 # Bug 253127 258 # Bug 253127
215 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
216 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
217 fi 261 fi
218 262
219 # Bug 261632 263 # Bug 261632
220 if use ppc64; then 264 if use ppc64; then
221 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
222 append-flags -mminimal-toc 266 append-flags -mminimal-toc
223 fi 267 fi
224 268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 if ! version_is_at_least 4.8; then
287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
289 fi
290
225 # Bug 172219 291 # Bug 172219
292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
293
294 if [[ ${CHOST} == *-darwin* ]]; then
295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
226 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
227 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
228 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
229 -e "s:X11R6/::" \ 311 -e "s:-arch\s\w*::g" \
230 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
231 314
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 316 # fix arch handling (automagically duplicates our -arch arg and breaks
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 317 # pch). Additionally disable Xarch support.
235 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
322 sed \
323 -e "s:-arch i386::" \
324 -e "s:-arch ppc::" \
325 -e "s:-arch x86_64::" \
326 -e "s:-arch ppc64::" \
327 -e "s:-arch \$i::" \
328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
330 -e "s:-Xarch_x86_64::g" \
331 -e "s:-Xarch_ppc64::g" \
332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
334
335 # On Snow Leopard don't fall back to 10.5 deployment target.
336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
341 fi
342 fi
343
344 # this one is needed for all systems with a separate -liconv, apart from
345 # Darwin, for which the sources already cater for -liconv
346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
348 -i config.tests/unix/iconv/iconv.pro \
349 || die "sed iconv.pro failed"
350 fi
351
352 # we need some patches for Solaris
353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
355 # use GCC over SunStudio
356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
357 # do not flirt with non-Prefix stuff, we're quite possessive
358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
236 360
237 base_src_prepare 361 base_src_prepare
238} 362}
239 363
240# @FUNCTION: qt4-build_src_configure 364# @FUNCTION: qt4-build_src_configure
241# @DESCRIPTION: 365# @DESCRIPTION:
242# Default configure phase 366# Default configure phase
243qt4-build_src_configure() { 367qt4-build_src_configure() {
244 setqtenv 368 setqtenv
245 myconf="$(standard_configure_options) ${myconf}"
246 369
247 echo ./configure ${myconf}
248 ./configure ${myconf} || die "./configure failed"
249 myconf=""
250}
251
252# @FUNCTION: qt4-build_src_compile
253# @DESCRIPTION: Actual compile phase
254qt4-build_src_compile() {
255 setqtenv
256 # Be backwards compatible for now
257 if [[ $EAPI != 2 ]]; then
258 qt4-build_src_configure
259 fi
260
261 build_directories "${QT4_TARGET_DIRECTORIES}"
262}
263
264# @FUNCTION: qt4-build_src_install
265# @DESCRIPTION:
266# Perform the actual installation including some library fixes.
267qt4-build_src_install() {
268 setqtenv
269 install_directories "${QT4_TARGET_DIRECTORIES}"
270 install_qconfigs
271 fix_library_files
272}
273
274# @FUNCTION: setqtenv
275setqtenv() {
276 # Set up installation directories
277 QTBASEDIR=/usr/$(get_libdir)/qt4
278 QTPREFIXDIR=/usr
279 QTBINDIR=/usr/bin
280 QTLIBDIR=/usr/$(get_libdir)/qt4
281 QMAKE_LIBDIR_QT=${QTLIBDIR}
282 QTPCDIR=/usr/$(get_libdir)/pkgconfig
283 QTDATADIR=/usr/share/qt4
284 QTDOCDIR=/usr/share/doc/qt-${PV}
285 QTHEADERDIR=/usr/include/qt4
286 QTPLUGINDIR=${QTLIBDIR}/plugins
287 QTSYSCONFDIR=/etc/qt4
288 QTTRANSDIR=${QTDATADIR}/translations
289 QTEXAMPLESDIR=${QTDATADIR}/examples
290 QTDEMOSDIR=${QTDATADIR}/demos
291 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4
292 PLATFORM=$(qt_mkspecs_dir)
293
294 unset QMAKESPEC
295}
296
297# @FUNCTION: standard_configure_options
298# @DESCRIPTION:
299# Sets up some standard configure options, like libdir (if necessary), whether
300# debug info is wanted or not.
301standard_configure_options() {
302 local myconf="" 370 local conf="
303 371 -prefix ${QTPREFIXDIR}
304 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 372 -bindir ${QTBINDIR}
305 373 -libdir ${QTLIBDIR}
306 # Disable visibility explicitly if gcc version isn't 4 374 -docdir ${QTDOCDIR}
307 if [[ "$(gcc-major-version)" -lt "4" ]]; then 375 -headerdir ${QTHEADERDIR}
308 myconf="${myconf} -no-reduce-exports" 376 -plugindir ${QTPLUGINDIR}
309 fi 377 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
310 378 -datadir ${QTDATADIR}
311 # precompiled headers doesn't work on hardened, where the flag is masked. 379 -translationdir ${QTTRANSDIR}
312 if use pch; then 380 -sysconfdir ${QTSYSCONFDIR}
313 myconf="${myconf} -pch" 381 -examplesdir ${QTEXAMPLESDIR}
314 else 382 -demosdir ${QTDEMOSDIR}
315 myconf="${myconf} -no-pch" 383 -opensource -confirm-license
316 fi 384 -shared -fast -largefile -stl -verbose
317 385 -nomake examples -nomake demos"
318 if use debug; then
319 myconf="${myconf} -debug -no-separate-debug-info"
320 else
321 myconf="${myconf} -release -no-separate-debug-info"
322 fi
323 386
324 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 387 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
325 # $(tc-arch). Therefore we convert it to supported values. 388 # $(tc-arch). Therefore we convert it to supported values.
326 case "$(tc-arch)" in 389 case "$(tc-arch)" in
327 amd64) myconf="${myconf} -arch x86_64" ;; 390 amd64|x64-*) conf+=" -arch x86_64" ;;
391 ppc-macos) conf+=" -arch ppc" ;;
328 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 392 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
393 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
394 x86-macos) conf+=" -arch x86" ;;
329 x86|x86-*) myconf="${myconf} -arch i386" ;; 395 x86|x86-*) conf+=" -arch i386" ;;
330 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 396 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
331 hppa|sh) myconf="${myconf} -arch generic" ;; 397 hppa|sh) conf+=" -arch generic" ;;
332 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 398 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
333 esac 399 esac
334 400
335 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 401 conf+=" -platform $(qt_mkspecs_dir)"
336 local exceptions= 402
337 case "${PV}" in 403 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
338 4.6.*) 404
339 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then 405 # debug/release
340 exceptions="-no-exceptions" 406 if use debug; then
407 conf+=" -debug"
408 else
409 conf+=" -release"
410 fi
411 conf+=" -no-separate-debug-info"
412
413 # exceptions USE flag
414 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
415
416 # disable RPATH on Qt >= 4.8 (bug 380415)
417 version_is_at_least 4.8 && conf+=" -no-rpath"
418
419 # precompiled headers don't work on hardened, where the flag is masked
420 conf+=" $(qt_use pch)"
421
422 # -reduce-relocations
423 # This flag seems to introduce major breakage to applications,
424 # mostly to be seen as a core dump with the message "QPixmap: Must
425 # construct a QApplication before a QPaintDevice" on Solaris.
426 # -- Daniel Vergien
427 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
428
429 # this one is needed for all systems with a separate -liconv, apart from
430 # Darwin, for which the sources already cater for -liconv
431 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
432 conf+=" -liconv"
433 fi
434
435 if use_if_iuse glib; then
436 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
437 # avoid the -pthread argument
438 conf+=" ${glibflags//-pthread}"
439 unset glibflags
440 fi
441
442 if use_if_iuse qpa; then
443 echo
444 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
445 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
446 ewarn "disable it before reporting any bugs related to this useflag."
447 echo
448 conf+=" -qpa"
449 fi
450
451 if use aqua; then
452 # On (snow) leopard use the new (frameworked) cocoa code.
453 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
454 conf+=" -cocoa -framework"
455 # We need the source's headers, not the installed ones.
456 conf+=" -I${S}/include"
457 # Add hint for the framework location.
458 conf+=" -F${QTLIBDIR}"
459
460 # We are crazy and build cocoa + qt3support :-)
461 if use qt3support; then
462 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
463 -i configure || die
341 fi 464 fi
342 ;; 465 else
343 *) 466 conf+=" -no-framework"
344 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 467 fi
345 ;; 468 else
346 esac 469 # freetype2 include dir is non-standard, thus pass it to configure
470 conf+=" $(pkg-config --cflags-only-I freetype2)"
471 fi
347 472
348 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
349 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
350 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
351 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
352 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
353 -demosdir ${QTDEMOSDIR} -silent -fast
354 ${exceptions}
355 -reduce-relocations -nomake examples -nomake demos"
356
357 # Make eclass >= 4.5.x ready
358 case "${MY_PV}" in
359 4.5.* | 4.6.* )
360 myconf="${myconf} -opensource"
361 ;;
362 esac
363
364 echo "${myconf}" 473 conf+=" ${myconf}"
474 myconf=
475
476 echo ./configure ${conf}
477 ./configure ${conf} || die "./configure failed"
478
479 prepare_directories ${QT4_TARGET_DIRECTORIES}
365} 480}
481
482# @FUNCTION: qt4-build_src_compile
483# @DESCRIPTION:
484# Actual compile phase
485qt4-build_src_compile() {
486 setqtenv
487
488 build_directories ${QT4_TARGET_DIRECTORIES}
489}
490
491# @FUNCTION: qt4-build_src_test
492# @DESCRIPTION:
493# Runs tests only in target directories.
494qt4-build_src_test() {
495 # QtMultimedia does not have any test suite (bug #332299)
496 [[ ${PN} == qt-multimedia ]] && return
497
498 for dir in ${QT4_TARGET_DIRECTORIES}; do
499 emake -j1 check -C ${dir}
500 done
501}
502
503# @FUNCTION: fix_includes
504# @DESCRIPTION:
505# For MacOS X we need to add some symlinks when frameworks are
506# being used, to avoid complications with some more or less stupid packages.
507fix_includes() {
508 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
509 local frw dest f h rdir
510 # Some packages tend to include <Qt/...>
511 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
512
513 # Fake normal headers when frameworks are installed... eases life later
514 # on, make sure we use relative links though, as some ebuilds assume
515 # these dirs exist in src_install to add additional files
516 f=${QTHEADERDIR}
517 h=${QTLIBDIR}
518 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
519 f=${f#*/}
520 h=${h#*/}
521 done
522 rdir=${h}
523 f="../"
524 while [[ ${h} == */* ]] ; do
525 f="${f}../"
526 h=${h#*/}
527 done
528 rdir="${f}${rdir}"
529
530 for frw in "${D}${QTLIBDIR}"/*.framework; do
531 [[ -e "${frw}"/Headers ]] || continue
532 f=$(basename ${frw})
533 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
534 dosym "${rdir}"/${f}/Headers "${dest}"
535
536 # Link normal headers as well.
537 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
538 h=$(basename ${hdr})
539 dosym "../${rdir}"/${f}/Headers/${h} \
540 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
541 done
542 done
543 fi
544}
545
546# @FUNCTION: qt4-build_src_install
547# @DESCRIPTION:
548# Perform the actual installation including some library fixes.
549qt4-build_src_install() {
550 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
551 setqtenv
552
553 install_directories ${QT4_TARGET_DIRECTORIES}
554 install_qconfigs
555 fix_library_files
556 fix_includes
557
558 # remove .la files since we are building only shared Qt libraries
559 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
560}
561
562# @FUNCTION: setqtenv
563# @INTERNAL
564setqtenv() {
565 # Set up installation directories
566 QTPREFIXDIR=${EPREFIX}/usr
567 QTBINDIR=${EPREFIX}/usr/bin
568 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
569 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
570 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
571 QTHEADERDIR=${EPREFIX}/usr/include/qt4
572 QTPLUGINDIR=${QTLIBDIR}/plugins
573 QTIMPORTDIR=${QTLIBDIR}/imports
574 QTDATADIR=${EPREFIX}/usr/share/qt4
575 QTTRANSDIR=${QTDATADIR}/translations
576 QTSYSCONFDIR=${EPREFIX}/etc/qt4
577 QTEXAMPLESDIR=${QTDATADIR}/examples
578 QTDEMOSDIR=${QTDATADIR}/demos
579 QMAKE_LIBDIR_QT=${QTLIBDIR}
580 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
581
582 PLATFORM=$(qt_mkspecs_dir)
583
584 unset QMAKESPEC
585}
586
587# @FUNCTION: prepare_directories
588# @USAGE: < directories >
589# @INTERNAL
590# @DESCRIPTION:
591# Generates Makefiles for the given list of directories.
592prepare_directories() {
593 for x in "$@"; do
594 pushd "${S}"/${x} >/dev/null || die
595 einfo "Running qmake in: ${x}"
596 # avoid running over the maximum argument number, bug #299810
597 {
598 echo "${S}"/mkspecs/common/*.conf
599 find "${S}" -name '*.pr[io]'
600 } | xargs sed -i \
601 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
602 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
603 || die
604 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
605 popd >/dev/null || die
606 done
607}
608
366 609
367# @FUNCTION: build_directories 610# @FUNCTION: build_directories
368# @USAGE: < directories > 611# @USAGE: < directories >
612# @INTERNAL
369# @DESCRIPTION: 613# @DESCRIPTION:
370# Compiles the code in $QT4_TARGET_DIRECTORIES 614# Compiles the code in the given list of directories.
371build_directories() { 615build_directories() {
372 local dirs="$@"
373 for x in ${dirs}; do 616 for x in "$@"; do
374 cd "${S}"/${x} 617 pushd "${S}"/${x} >/dev/null || die
375 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 618 emake CC="$(tc-getCC)" \
376 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 619 CXX="$(tc-getCXX)" \
377 emake CC="@echo compiling \$< && $(tc-getCC)" \
378 CXX="@echo compiling \$< && $(tc-getCXX)" \
379 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 620 LINK="$(tc-getCXX)" || die "emake failed"
621 popd >/dev/null || die
380 done 622 done
381} 623}
382 624
383# @FUNCTION: install_directories 625# @FUNCTION: install_directories
384# @USAGE: < directories > 626# @USAGE: < directories >
627# @INTERNAL
385# @DESCRIPTION: 628# @DESCRIPTION:
386# run emake install in the given directories, which are separated by spaces 629# Runs emake install in the given directories, which are separated by spaces.
387install_directories() { 630install_directories() {
388 local dirs="$@"
389 for x in ${dirs}; do 631 for x in "$@"; do
390 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 632 pushd "${S}"/${x} >/dev/null || die
391 emake INSTALL_ROOT="${D}" install || die "emake install failed" 633 emake INSTALL_ROOT="${D}" install || die "emake install failed"
392 popd >/dev/null || die "Can't popd from ${S}/${x}" 634 popd >/dev/null || die
393 done 635 done
394} 636}
395 637
396# @ECLASS-VARIABLE: QCONFIG_ADD 638# @ECLASS-VARIABLE: QCONFIG_ADD
397# @DESCRIPTION: 639# @DESCRIPTION:
398# List options that need to be added to QT_CONFIG in qconfig.pri 640# List options that need to be added to QT_CONFIG in qconfig.pri
399QCONFIG_ADD="${QCONFIG_ADD:-}" 641: ${QCONFIG_ADD:=}
400 642
401# @ECLASS-VARIABLE: QCONFIG_REMOVE 643# @ECLASS-VARIABLE: QCONFIG_REMOVE
402# @DESCRIPTION: 644# @DESCRIPTION:
403# List options that need to be removed from QT_CONFIG in qconfig.pri 645# List options that need to be removed from QT_CONFIG in qconfig.pri
404QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 646: ${QCONFIG_REMOVE:=}
405 647
406# @ECLASS-VARIABLE: QCONFIG_DEFINE 648# @ECLASS-VARIABLE: QCONFIG_DEFINE
407# @DESCRIPTION: 649# @DESCRIPTION:
408# List variables that should be defined at the top of QtCore/qconfig.h 650# List variables that should be defined at the top of QtCore/qconfig.h
409QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 651: ${QCONFIG_DEFINE:=}
410 652
411# @FUNCTION: install_qconfigs 653# @FUNCTION: install_qconfigs
654# @INTERNAL
655# @DESCRIPTION:
412# @DESCRIPTION: Install gentoo-specific mkspecs configurations 656# Install gentoo-specific mkspecs configurations.
413install_qconfigs() { 657install_qconfigs() {
414 local x 658 local x
415 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 659 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
416 for x in QCONFIG_ADD QCONFIG_REMOVE; do 660 for x in QCONFIG_ADD QCONFIG_REMOVE; do
417 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 661 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
418 done 662 done
419 insinto ${QTDATADIR}/mkspecs/gentoo 663 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
420 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 664 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
421 fi 665 fi
422 666
423 if [[ -n ${QCONFIG_DEFINE} ]]; then 667 if [[ -n ${QCONFIG_DEFINE} ]]; then
424 for x in ${QCONFIG_DEFINE}; do 668 for x in ${QCONFIG_DEFINE}; do
425 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 669 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
426 done 670 done
427 insinto ${QTHEADERDIR}/Gentoo 671 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
428 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 672 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
429 fi 673 fi
430} 674}
431 675
432# @FUNCTION: generate_qconfigs 676# @FUNCTION: generate_qconfigs
433# @DESCRIPTION: Generates gentoo-specific configurations 677# @INTERNAL
678# @DESCRIPTION:
679# Generates gentoo-specific qconfig.{h,pri}.
434generate_qconfigs() { 680generate_qconfigs() {
435 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 681 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
436 local x qconfig_add qconfig_remove qconfig_new 682 local x qconfig_add qconfig_remove qconfig_new
437 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 683 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
438 [[ -f ${x} ]] || continue 684 [[ -f ${x} ]] || continue
439 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 685 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
440 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 686 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
441 done 687 done
442 688
443 # these error checks do not use die because dying in pkg_post{inst,rm} 689 # these error checks do not use die because dying in pkg_post{inst,rm}
444 # just makes things worse. 690 # just makes things worse.
445 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 691 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
452 698
453 # generate list of QT_CONFIG entries from the existing list 699 # generate list of QT_CONFIG entries from the existing list
454 # including qconfig_add and excluding qconfig_remove 700 # including qconfig_add and excluding qconfig_remove
455 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 701 for x in $(sed -n 's/^QT_CONFIG +=//p' \
456 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 702 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
457 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 703 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
458 done 704 done
459 705
460 # replace the existing QT_CONFIG list with qconfig_new 706 # replace the existing QT_CONFIG list with qconfig_new
461 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 707 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
462 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 708 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
486 fi 732 fi
487 fi 733 fi
488} 734}
489 735
490# @FUNCTION: qt4-build_pkg_postrm 736# @FUNCTION: qt4-build_pkg_postrm
737# @DESCRIPTION:
491# @DESCRIPTION: Generate configurations when the package is completely removed 738# Regenerate configuration when the package is completely removed.
492qt4-build_pkg_postrm() { 739qt4-build_pkg_postrm() {
493 generate_qconfigs 740 generate_qconfigs
494} 741}
495 742
496# @FUNCTION: qt4-build_pkg_postinst 743# @FUNCTION: qt4-build_pkg_postinst
744# @DESCRIPTION:
497# @DESCRIPTION: Generate configuration, plus throws a message about possible 745# Regenerate configuration, plus throw a message about possible
498# breakages and proposed solutions. 746# breakages and proposed solutions.
499qt4-build_pkg_postinst() { 747qt4-build_pkg_postinst() {
500 generate_qconfigs 748 generate_qconfigs
501
502 if [[ "${PN}" == "qt-core" ]]; then
503 echo
504 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
505 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
506 ewarn "should recompile the packages providing these plugins. Also, make sure you"
507 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
508 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
509 ewarn
510 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
511 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
512 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
513 ewarn "configuration."
514 ewarn
515 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
516 echo
517 fi
518} 749}
519 750
520# @FUNCTION: skip_qmake_build_patch 751# @FUNCTION: skip_qmake_build
752# @INTERNAL
521# @DESCRIPTION: 753# @DESCRIPTION:
522# Don't need to build qmake, as it's already installed from qt-core 754# Patches configure to skip qmake compilation, as it's already installed by qt-core.
523skip_qmake_build_patch() { 755skip_qmake_build() {
524 # Don't need to build qmake, as it's already installed from qt-core
525 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 756 sed -i -e "s:if true:if false:g" "${S}"/configure || die
526} 757}
527 758
528# @FUNCTION: skip_project_generation_patch 759# @FUNCTION: skip_project_generation
760# @INTERNAL
529# @DESCRIPTION: 761# @DESCRIPTION:
530# Exit the script early by throwing in an exit before all of the .pro files are scanned 762# Exit the script early by throwing in an exit before all of the .pro files are scanned.
531skip_project_generation_patch() { 763skip_project_generation() {
532 # Exit the script early by throwing in an exit before all of the .pro files are scanned
533 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 764 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
534 -i "${S}"/configure || die "Sed failed"
535} 765}
536 766
537# @FUNCTION: symlink_binaries_to_buildtree 767# @FUNCTION: symlink_binaries_to_buildtree
768# @INTERNAL
538# @DESCRIPTION: 769# @DESCRIPTION:
539# Symlink generated binaries to buildtree so they can be used during compilation 770# Symlinks generated binaries to buildtree, so they can be used during compilation time.
540# time
541symlink_binaries_to_buildtree() { 771symlink_binaries_to_buildtree() {
542 for bin in qmake moc uic rcc; do 772 for bin in qmake moc uic rcc; do
543 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 773 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
544 done 774 done
545} 775}
546 776
547# @FUNCTION: fix_library_files 777# @FUNCTION: fix_library_files
778# @INTERNAL
548# @DESCRIPTION: 779# @DESCRIPTION:
549# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 780# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
550# moves the *.pc-files into the pkgconfig directory 781# moves the *.pc files into the pkgconfig directory.
551fix_library_files() { 782fix_library_files() {
783 local libfile
552 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 784 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
553 if [[ -e ${libfile} ]]; then 785 if [[ -e ${libfile} ]]; then
554 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 786 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
555 fi 787 fi
556 done 788 done
557 789
558 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 790 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
559 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 791 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
560 if [[ -e ${libfile} ]]; then 792 if [[ -e ${libfile} ]]; then
561 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 793 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
562 794
563 # Move .pc files into the pkgconfig directory 795 # Move .pc files into the pkgconfig directory
564 dodir ${QTPCDIR} 796 dodir ${QTPCDIR#${EPREFIX}}
565 mv ${libfile} "${D}"/${QTPCDIR}/ \ 797 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
566 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
567 fi 798 fi
568 done 799 done
569 800
570 # Don't install an empty directory 801 # Don't install an empty directory
571 rmdir "${D}"/${QTLIBDIR}/pkgconfig 802 rmdir "${D}"/${QTLIBDIR}/pkgconfig
572} 803}
573 804
574# @FUNCTION: qt_use 805# @FUNCTION: qt_use
575# @USAGE: < flag > [ feature ] [ enableval ] 806# @USAGE: < flag > [ feature ] [ enableval ]
576# @DESCRIPTION: 807# @DESCRIPTION:
577# This will echo "${enableval}-${feature}" if <flag> is enabled, or 808# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
578# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 809# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
579# will be used for that. If [enableval] is not specified, it omits the 810# will be used for that. If [enableval] is not specified, it omits the
580# assignment-part 811# "-${enableval}" part.
581qt_use() { 812qt_use() {
582 local flag="${1}" 813 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
583 local feature="${1}"
584 local enableval=
585
586 [[ -n ${2} ]] && feature=${2}
587 [[ -n ${3} ]] && enableval="-${3}"
588
589 if use ${flag}; then
590 echo "${enableval}-${feature}"
591 else
592 echo "-no-${feature}"
593 fi
594}
595
596# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
597# @DESCRIPTION:
598# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
599# (eutils.eclass), line per line.
600#
601# Example:
602# @CODE
603# pkg_setup() {
604# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
605# ~x11-libs/qt-gui-${PV} qt3support"
606# qt4-build_check_use
607# }
608# @CODE
609
610# Run built_with_use on each flag and print appropriate error messages if any
611# flags are missing
612
613_qt_built_with_use() {
614 local missing opt pkg flag flags
615
616 if [[ ${1} = "--missing" ]]; then
617 missing="${1} ${2}" && shift 2
618 fi
619 if [[ ${1:0:1} = "-" ]]; then
620 opt=${1} && shift
621 fi
622
623 pkg=${1} && shift
624
625 for flag in "${@}"; do
626 flags="${flags} ${flag}"
627 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
628 flags="${flags}*"
629 else
630 [[ ${opt} = "-o" ]] && return 0
631 fi
632 done
633 if [[ "${flags# }" = "${@}" ]]; then
634 return 0
635 fi
636 if [[ ${opt} = "-o" ]]; then
637 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
638 else
639 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
640 fi
641 return 1
642}
643
644# @FUNCTION: qt4-build_check_use
645# @DESCRIPTION:
646# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
647# USE flags listed.
648#
649# If any of the required USE flags are missing, an eerror will be printed for
650# each package with missing USE flags.
651qt4-build_check_use() {
652 local line missing
653 while read line; do
654 [[ -z ${line} ]] && continue
655 if ! _qt_built_with_use ${line}; then
656 missing=true
657 fi
658 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
659 if [[ -n ${missing} ]]; then
660 echo
661 eerror "Flags marked with an * are missing."
662 die "Missing USE flags found"
663 fi
664} 814}
665 815
666# @FUNCTION: qt_mkspecs_dir 816# @FUNCTION: qt_mkspecs_dir
667# @RETURN: the specs-directory w/o path 817# @RETURN: the specs-directory w/o path
668# @DESCRIPTION: 818# @DESCRIPTION:
669# Allows us to define which mkspecs dir we want to use. 819# Allows us to define which mkspecs dir we want to use.
670qt_mkspecs_dir() { 820qt_mkspecs_dir() {
671 # Allows us to define which mkspecs dir we want to use.
672 local spec 821 local spec=
673 822
674 case ${CHOST} in 823 case "${CHOST}" in
675 *-freebsd*|*-dragonfly*) 824 *-freebsd*|*-dragonfly*)
676 spec="freebsd" ;; 825 spec=freebsd ;;
677 *-openbsd*) 826 *-openbsd*)
678 spec="openbsd" ;; 827 spec=openbsd ;;
679 *-netbsd*) 828 *-netbsd*)
680 spec="netbsd" ;; 829 spec=netbsd ;;
681 *-darwin*) 830 *-darwin*)
831 if use aqua; then
832 # mac with carbon/cocoa
833 spec=macx
834 else
835 # darwin/mac with x11
682 spec="darwin" ;; 836 spec=darwin
837 fi
838 ;;
839 *-solaris*)
840 spec=solaris ;;
683 *-linux-*|*-linux) 841 *-linux-*|*-linux)
684 spec="linux" ;; 842 spec=linux ;;
685 *) 843 *)
686 die "Unknown CHOST, no platform choosen." 844 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
687 esac 845 esac
688 846
689 CXX=$(tc-getCXX) 847 case "$(tc-getCXX)" in
690 if [[ ${CXX/g++/} != ${CXX} ]]; then 848 *g++*)
691 spec="${spec}-g++" 849 spec+=-g++ ;;
692 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 850 *icpc*)
693 spec="${spec}-icc" 851 spec+=-icc ;;
694 else 852 *)
695 die "Unknown compiler ${CXX}." 853 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
696 fi 854 esac
697 if [[ -n "${LIBDIR/lib}" ]]; then 855
698 spec="${spec}-${LIBDIR/lib}" 856 # Add -64 for 64bit profiles
857 if use x64-freebsd ||
858 use amd64-linux ||
859 use x64-macos ||
860 use x64-solaris ||
861 use sparc64-solaris
862 then
863 spec+=-64
699 fi 864 fi
700 865
701 echo "${spec}" 866 echo "${spec}"
702} 867}
703 868
704case ${EAPI:-0} in 869# @FUNCTION: qt_assistant_cleanup
705 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 870# @INTERNAL
871# @DESCRIPTION:
872# Tries to clean up tools.pro for qt-assistant ebuilds.
873# Meant to be called in src_prepare().
874# Since Qt 4.7.4 this function is a no-op.
875qt_assistant_cleanup() {
876 # apply patching to qt-assistant ebuilds only
877 [[ ${PN} != qt-assistant ]] && return
878
879 # no longer needed for 4.7.4 and later
880 version_is_at_least 4.7.4 && return
881
882 # different versions (and branches...) may need different handling,
883 # add a case if you need special handling
884 case "${MY_PV_EXTRA}" in
885 *kde-qt*)
886 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
887 -e "/mac/,/^embedded.*makeqpf$/d" \
888 -i tools/tools.pro || die "patching tools.pro failed"
889 ;;
890 *)
891 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
892 -e "/mac/,/^embedded.*makeqpf$/d" \
893 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
894 -i tools/tools.pro || die "patching tools.pro failed"
895 ;;
896 esac
897}
898
899# @FUNCTION: qt_nolibx11
900# @INTERNAL
901# @DESCRIPTION:
902# Ignore X11 tests for packages that don't need X libraries installed.
903qt_nolibx11() {
904 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
905 die "x11 check sed failed"
906}
907
706 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 908EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
707esac

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.128

  ViewVC Help
Powered by ViewVC 1.1.20